function Person(first, last, age, gender, interests) {
    // property and method definitions
    this.name ={
        'first': first,
        'last': last
    };
    this.age = age;
    this.gender = gender;
    this.interests = interests;
}

let person1 = new Person('Bob', 'Smith',  32, 'male', ['music', 'skiing']);
console.log(person1);

// create()
let person2 = Object.create(person1); 

// modification of prototypes
let person3 = new Person('Tami', 'Smith',  32, 'neutral', ['music', 'skiing', 'kickboxing']);
Person.prototype.farewell = function() {
    alert(this.name.first + ' has left the building. Bye for now!');
}
Person.prototype.fullname = 'Bob Smith';
Person.prototype.fullname = this.name.first + ' ' + this.name.last;

// comparing prototype-based OOP with classical OOP
let animal = {hasChlorophyll: false};
let dog = Object.create(animale);
Object.assign(dog, {
    speak() {
        console.log("Woof!");
    }
});

let Susan = Object.create(dog);
Object.assign(Susan, {
    name: "Susan"
});

Susan.speak();

/*
In classical OOP: 
1. Create class Animal with private data boolean hasChlorophyll 
    - in the constructor set hahChlorophyll to false
2. Create class Dog which extends Animal 
    - create method spreak which displays "Woof"
3. In the main method create object Susan of type Dog 
    - call the method speak()
*/

/* Advantages of prototype-based OOP */
// methods that inherit via the prototype chain can be changed for all instances
function Class() {}
Class.prototype.calc = function(a, b) {
    return a + b;
}

// Create 2 instances
var ins1 = new Class(),
    ins2 =  new Class();

// Test the calc method 
console.log(ins1.calc(1, 1), ins2.calc(1, 1)); // => 2, 2

// Change the prototype method
Class.prototype.calc = function() {
    var args = Array.prototype.slice.apply(arguments),
        res = 0, c;
    
        while(c = args.shift())
            res += c;
        
        return res;
}

// Test the calc method
console.log(ins1.calc(1, 1, 1), ins2.calc(1, 1, 1)); // => 3, 3

/* Disadvantages of prototype-based OOP */
// we loose confidence in static writing
function MyObject() {
    var foo = 1;
    this.bar = 2;
}

MyObject.prototype.getFoo = function() {
    // can't access "foo" here!
}

MyObject.prototype.getBar = function() {
    return this.bar; // OK!
}